Description

If you have smart variable matcher for environment, add another matcher for FQDN, and try to edit host afterwards, it will fail with the

following error:

ArgumentError

comparison of Array with Array failed

app/services/classification/base.rb:41:in `block in values_hash'

app/services/classification/base.rb:39:in `values_hash'

app/services/classification/base.rb:17:in `inherited_values'

app/views/puppetclasses/_class_parameters.html.erb:2:in `_6bd4e894887042c12c1c876d3bbd59b5'

app/views/puppetclasses/_classes_parameters.html.erb:12:in `_efecede07e99fec46c2aace6cca47e7e'

app/views/hosts/_form.html.erb:96:in `block (2 levels) in _d083b3a0d59e018a9d7bfcdea74457b4'

app/helpers/layout_helper.rb:273:in `form_for'

app/views/hosts/_form.html.erb:8:in `block in _d083b3a0d59e018a9d7bfcdea74457b4'

app/models/taxonomy.rb:61:in `block (2 levels) in as_taxonomy'

app/models/concerns/foreman/thread_session.rb:147:in `as_location'

app/models/taxonomy.rb:60:in `block in as_taxonomy'

app/models/concerns/foreman/thread_session.rb:112:in `as_org'

app/models/taxonomy.rb:59:in `as_taxonomy'

app/views/hosts/_form.html.erb:6:in `_d083b3a0d59e018a9d7bfcdea74457b4'

app/views/hosts/edit.html.erb:9:in `_ad432273d701fcf94b0032cbe38693a1'

app/controllers/concerns/application_shared.rb:13:in `set_timezone'

app/models/concerns/foreman/thread_session.rb:32:in `clear_thread'

lib/middleware/catch_json_parse_errors.rb:9:in `call'

 Moreover, the following errors will appear in Puppet reports:

Could not retrieve catalog from remote server: Error 400 on SERVER: Failed when searching for node

 test.node.local: Failed to find test.node.local via exec: Execution of '/etc/puppet/node.rb test.

node.local' returned 1:

 In my case, I have a Puppet class variable "deploy_keys" and a smart variable matcher: "environment = staging".

Later on, I add matcher "fqdn = test.node.local" and voila, errors start to appear.

Foreman version: 1.8.2

Related issues:

Related to Foreman - Bug #8333: Incorrect matcher values with multi-key matchers Closed 11/10/2014

History

#1 - 07/14/2015 07:31 AM - Dominic Cleal

- Category set to Parameters

- translation missing: en.field_release set to 62

Perhaps related to #8333, it changed the classification sorting.
https://projects.theforeman.org/issues/8333


#2 - 07/14/2015 07:31 AM - Dominic Cleal

- Related to Bug #8333: Incorrect matcher values with multi-key matchers added

#3 - 07/14/2015 07:55 AM - Ori Rabin

- Status changed from New to Need more information

Juris,

I wasn't able to reproduce.

I'm assuming because of the error that the parameter type is array.

Can you please add the values you gave for each matcher?

Are you using merge overrides?

#4 - 07/14/2015 08:28 AM - Juris Pavlyuchenkov

- File Screenshot 2015-07-14 15.28.01.png added

- File Screenshot 2015-07-14 15.27.17.png added

Parameter type is set as string and I do not use merge overrides.

Please find the screenshots attached.

#5 - 07/15/2015 06:17 AM - Dominic Cleal

- Status changed from Need more information to New

#6 - 07/29/2015 09:07 AM - Tomer Brisker

Could not reproduce with 1.8.2.

Note that your "order" field doesn't contain environment at all.

#7 - 07/30/2015 08:29 AM - Juris Pavlyuchenkov

Tomer Brisker wrote:

Could not reproduce with 1.8.2.

Note that your "order" field doesn't contain environment at all.

 Here it is! Added "environment" to "order" field and it works now. Thank you!

#8 - 07/31/2015 03:57 AM - Dominic Cleal

- Subject changed from Multiple matchers fail with "comparison of Array with Array failed" to Matcher for unlisted attribute fails with "comparison of

Array with Array failed"

- translation missing: en.field_release deleted (62)

Thanks for confirming!
